<?php

class url_shortener{

	const API_URL = 'http://192.168.1.80/projects/public_api/shortening_site/api.php';
	
	private static function send_post_data($data){
		$url = parse_url(self::API_URL);
		$boundry = md5(microtime(true));
		
		$post = '';
		
		foreach($data as $name => $value){
			$post .= "--{$boundry}\r\n";
			$post .= "Content-Disposition: form-data; name=\"{$name}\"\r\n\r\n";
			$post .= $value."\r\n";
		}	
		
		$post .= "--{$boundry}--\r\n";
		if(isset($url['query'])){
			$head = "POST {$url['path']}?{$url['query']} HTTP/1.1\r\n";
		}else{
			$head = "POST {$url['path']} HTTP/1.1\r\n";
		}
		$head .= "Host: {$url['host']}\r\n";
		$head .= "Content-Type: multipart/form-data; boundry=\"{$boundry}\"\r\n";
		$head .= "Content-Length: ". strlen($post) . "\r\n";
		$head .= "Connection: close\r\n\r\n";
		
		$socket = fsockopen($url['host'], (isset($url['port'])) ? $url['port'] : 80);
		
		fwrite($socket, "{$head}{$post}");
			
		$explode = explode("\r\n\r\n", stream_get_contents($socket));	
		
		return end($explode);
	}
	
	//gets the URL for the given key.
	public static function lookup($key){
		return json_decode(self::send_post_data(array('lookup' => $key)), true);
	}
	
	public static function shorten($url){
		return json_decode(self::send_post_data(array('shorten' => $url)), true);
	}

}

?>